Package opennlp.tools.ml.maxent.quasinewton

# Class QNTrainer

java.lang.Object
opennlp.tools.ml.AbstractTrainer
opennlp.tools.ml.AbstractEventTrainer
opennlp.tools.ml.maxent.quasinewton.QNTrainer

All Implemented Interfaces:
  `Trainer`, `EventTrainer`

public class QNTrainer extends AbstractEventTrainer
A Maxent model `trainer` using the L-BFGS algorithm.

See Also:
  - `AbstractEventTrainer`
  - `QNMinimizer`
  - `QNModel`
  - `Trainer`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final double`
  `L1COST_DEFAULT`
  The default L1-cost value is `0.1d`.
  `static final String`
  `L1COST_PARAM`
  `static final double`
  `L2COST_DEFAULT`
  The default L2-cost value is `0.1d`.
  `static final String`
  `L2COST_PARAM`
  `static final int`
  `M_DEFAULT`
  The default number of Hessian updates to store is `15`.
  `static final String`
  `M_PARAM`
  `static final int`
  `MAX_FCT_EVAL_DEFAULT`
  The default maximum number of function evaluations is `30,000`.
  `static final String`
  `MAX_FCT_EVAL_PARAM`
  `static final String`
  `MAXENT_QN_VALUE`
  `static final int`
  `THREADS_DEFAULT`
  `static final String`
  `THREADS_PARAM`

  ### Fields inherited from class opennlp.tools.ml.AbstractEventTrainer

  `DATA_INDEXER_ONE_PASS_REAL_VALUE, DATA_INDEXER_ONE_PASS_VALUE, DATA_INDEXER_PARAM, DATA_INDEXER_TWO_PASS_VALUE`

  ### Fields inherited from interface opennlp.tools.ml.EventTrainer

  `EVENT_VALUE`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `QNTrainer()`
  Initializes a `QNTrainer`.
  `QNTrainer(int m)`
  Initializes a `QNTrainer` with the specified parameter `m`.
  `QNTrainer(int m, int maxFctEval)`
  Initializes a `QNTrainer` with the specified parameters.
  `QNTrainer(TrainingParameters parameters)`
  Initializes a `QNTrainer` with the specified `parameters`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `AbstractModel`
  `doTrain(DataIndexer indexer)`
  `void`
  `init(TrainingParameters trainingParameters, Map<String,String> reportMap)`
  Initializes a `AbstractTrainer` via `TrainingParameters` and a `report map`.
  `boolean`
  `isSortAndMerge()`
  `QNModel`
  `trainModel(int iterations, DataIndexer indexer)`
  Trains a `model` using the QN algorithm.
  `void`
  `validate()`
  Checks the configured `parameters`.

  ### Methods inherited from class opennlp.tools.ml.AbstractEventTrainer

  `getDataIndexer, train, train`

  ### Methods inherited from class opennlp.tools.ml.AbstractTrainer

  `getAlgorithm, getCutoff, getIterations, getTrainingConfiguration, init`

  ### Methods inherited from class java.lang.Object

  `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface opennlp.tools.commons.Trainer

  `init`

- ## Field Details

  - ### MAXENT_QN_VALUE

    public static final String MAXENT_QN_VALUE
    See Also:
      - Constant Field Values

  - ### THREADS_PARAM

    public static final String THREADS_PARAM
    See Also:
      - Constant Field Values

  - ### THREADS_DEFAULT

    public static final int THREADS_DEFAULT
    See Also:
      - Constant Field Values

  - ### L1COST_PARAM

    public static final String L1COST_PARAM
    See Also:
      - Constant Field Values

  - ### L1COST_DEFAULT

    public static final double L1COST_DEFAULT
    The default L1-cost value is `0.1d`.
    See Also:
      - Constant Field Values

  - ### L2COST_PARAM

    public static final String L2COST_PARAM
    See Also:
      - Constant Field Values

  - ### L2COST_DEFAULT

    public static final double L2COST_DEFAULT
    The default L2-cost value is `0.1d`.
    See Also:
      - Constant Field Values

  - ### M_PARAM

    public static final String M_PARAM
    See Also:
      - Constant Field Values

  - ### M_DEFAULT

    public static final int M_DEFAULT
    The default number of Hessian updates to store is `15`.
    See Also:
      - Constant Field Values

  - ### MAX_FCT_EVAL_PARAM

    public static final String MAX_FCT_EVAL_PARAM
    See Also:
      - Constant Field Values

  - ### MAX_FCT_EVAL_DEFAULT

    public static final int MAX_FCT_EVAL_DEFAULT
    The default maximum number of function evaluations is `30,000`.
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### QNTrainer

    public QNTrainer()
    Initializes a `QNTrainer`.

  - ### QNTrainer

    public QNTrainer(TrainingParameters parameters)
    Initializes a `QNTrainer` with the specified `parameters`.
    Parameters:
      `parameters` - The `TrainingParameters` to use.

  - ### QNTrainer

    public QNTrainer(int m)
    Initializes a `QNTrainer` with the specified parameter `m`.
    Parameters:
      `m` - The number of hessian updates to store.

  - ### QNTrainer

    public QNTrainer(int m, int maxFctEval)
    Initializes a `QNTrainer` with the specified parameters.
    Parameters:
      `m` - The number of hessian updates to store.

- ## Method Details

  - ### init

    public void init(TrainingParameters trainingParameters, Map<String,String> reportMap)
    Description copied from class: `AbstractTrainer`
    Initializes a `AbstractTrainer` via `TrainingParameters` and a `report map`.
    Specified by:
      `init` in interface `Trainer`
    Overrides:
      `init` in class `AbstractTrainer`
    Parameters:
      `trainingParameters` - The `TrainingParameters` to use.
      `reportMap` - The `Map` instance used as report map.

  - ### validate

    public void validate()
    Description copied from class: `AbstractTrainer`
    Checks the configured `parameters`. If a subclass overrides this, it should call `super.validate();`.
    Overrides:
      `validate` in class `AbstractEventTrainer`

  - ### isSortAndMerge

    public boolean isSortAndMerge()
    Specified by:
      `isSortAndMerge` in class `AbstractEventTrainer`

  - ### doTrain

    public AbstractModel doTrain(DataIndexer indexer) throws IOException
    Specified by:
      `doTrain` in class `AbstractEventTrainer`
    Throws:
      `IOException`

  - ### trainModel

    public QNModel trainModel(int iterations, DataIndexer indexer)
    Trains a `model` using the QN algorithm.
    Parameters:
      `iterations` - The number of QN iterations to perform.
      `indexer` - The `DataIndexer` used to compress events in memory.
    Returns:
      A trained `QNModel` which can be used immediately or saved to disk using an `QNModelWriter`.
    Throws:
      `IllegalArgumentException` - Thrown if parameters were invalid.